#include <bits/stdc++.h>
using namespace std;
using lint = long long;
using pi = array<int, 2>;
#define sz(v) ((int)(v).size())
#define all(v) (v).begin(), (v).end()
#define cr(v, n) (v).clear(), (v).resize(n);

array<int, 2> roadwork(string S);

string rep(string s, int k) {
	string ans;
	for (int i = 0; i < k; i++)
		ans += s;
	return ans;
}

class XorShift64 {
	unsigned long long x;

  public:
	XorShift64(unsigned long long seed) : x((seed + 14213124131ull) ^ 103920984124ull) {}

	unsigned long long operator()() {
		x = x ^ (x << 13);
		x = x ^ (x >> 7);
		x = x ^ (x << 17);
		return x;
	}

	template <typename T> T uniform(T mn, T mx) { return mn + (T)((*this)() % (mx - mn + 1)); }
};

XorShift64 rd(0x20250118);

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string type;
	int k;
	cin >> type >> k;
	vector<string> todo;
	if (type == "random") {
		int n = (1 << k);
		string s = rep("AB", n - 1);
		for (int i = 0; i < 10; i++) {
			for (int j = i%2+1; j <= sz(s); j+=i+1) {
				swap(s[j - 1], s[rd.uniform(0, j - 1)]);
			}
			todo.push_back(s);
		}
	}
	if (type == "random_flexsize") {
		int n = (1 << k);
		for (int i = 0; i < 10; i++) {
			string s = rep("AB", n - 1 - rd.uniform(0, (4 * n) / 10));
			for (int j = i%2+1; j <= sz(s); j+=i+1) {
				swap(s[j - 1], s[rd.uniform(0, j - 1)]);
			}
			todo.push_back(s);
		}
	}
	if (type == "hand") {
		if (k == -1) { // hand -1 is sample.
			todo.push_back("AB");
			todo.push_back("AABBAABBAABB");
		} else {
			int n = (1 << k);
			todo.push_back(rep("A", n - 1) + rep("B", n - 1));
			todo.push_back(rep("B", n - 1) + rep("A", n - 1));
			todo.push_back(rep("BA", n - 1));
			todo.push_back(rep("AB", n - 1));
			int n1 = (1 << (k / 2)), n2 = (1 << (k - k / 2));
			{
				string s1 = rep(rep("A", n1) + rep("B", n1), n2);
				s1=s1.substr(1, sz(s1) - 2);
				todo.push_back(s1);
			}
			swap(n1, n2);
			{
				string s1 = rep(rep("A", n1) + rep("B", n1), n2);
				s1=s1.substr(1, sz(s1) - 2);
				todo.push_back(s1);
			}
			if (k > 1) {
				todo.push_back(rep("AB", n / 4) + rep("A", n / 2) + rep("B", n / 2) + rep("AB", n / 4 - 1));
				todo.push_back(rep("AB", n / 4) + rep("B", n / 2) + rep("A", n / 2) + rep("AB", n / 4 - 1));
				todo.push_back(rep("A", n / 2 - 1) + rep("AB", n / 2) + rep("B", n / 2 - 1));
				todo.push_back(rep("B", n / 2 - 1) + rep("AB", n / 2) + rep("A", n / 2 - 1));
			}
		}
	}
	
	// begin validation:
	{
	    if(k == -1) k = 3;
	    int maxn = 0;
    	for (auto &x : todo) {
    		maxn = max(maxn, sz(x) / 2 + 1);
    	}
    	assert(1 <= sz(todo) && sz(todo) <= 10);
    	assert(maxn <= (1 << k));
	}
	// end validation.
	cout << sz(todo) << "\n";
	for (auto &x : todo) {
	    auto [p, q] = roadwork(x);
		cout << p << "\n" << q << "\n";
	}
}
